'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _plugins = require('./plugins');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_PORT = 8080; /**************************************************
                          * Created by nanyuantingfeng on 23/08/2017 17:19.
                          **************************************************/

var DEFAULT_HOST = '127.0.0.1';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = (0, _keys2.default)(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    if (typeof target === 'string') {
      oo[key] = (0, _extends3.default)({ target: target }, options);
    } else {
      oo[key] = (0, _extends3.default)({}, target, options);
    }
  });
  return oo;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var devServer, proxy, proxyOptions, plugins;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.devServer = {};
            context.proxy = {};
            context.proxyOptions = { changeOrigin: true };

            next();

            devServer = context.devServer, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins;


            context.webpackConfig.devServer = context.devServer = (0, _extends3.default)({
              hot: true,
              hotOnly: true,
              contentBase: false,
              inline: true,
              noInfo: false,
              host: DEFAULT_HOST,
              port: context.port || DEFAULT_PORT,
              historyApiFallback: true,
              overlay: true,
              proxy: parseProxyWithOptions(proxy, proxyOptions)
            }, devServer);

            plugins.push.apply(plugins, [new _plugins.HotModuleReplacementPlugin(), new _plugins.NamedModulesPlugin()]);

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];