'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var hash, compress, ENV, cache, packageMap, plugins, dll, cssFileName, commonName;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.CaseSensitivePathsPlugin(), new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path2.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });
                  return;
                }
                var error = errors[0];
                _util.notifier.notify({
                  title: 'hollow cli',
                  message: severity + ' : ' + error.name,
                  subtitle: error.file || '',
                  contentImage: _path2.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler), new _plugins.NoEmitOnErrorsPlugin(), new _plugins.ModuleConcatenationPlugin()];

            next();

            hash = context.hash, compress = context.compress, ENV = context.ENV, cache = context.cache, packageMap = context.packageMap, plugins = context.plugins, dll = context.dll;
            cssFileName = hash ? '[name]-[chunkhash].css' : '[name].css';
            commonName = hash ? 'common-[chunkhash].js' : 'common.js';


            if (!Array.isArray(dll)) {
              plugins.push(new _plugins.CommonsChunkPlugin({
                name: 'common',
                filename: commonName,
                minChunks: 4
              }));
            }

            if (ENV.isProduction) {
              plugins.push(new _plugins.ExtractTextPlugin({
                filename: cssFileName,
                disable: false,
                allChunks: true
              }));
              plugins.push(new _plugins.HashedModuleIdsPlugin());
            }

            if (compress === true) {
              plugins.push(new _plugins.UglifyJsPlugin({
                output: { ascii_only: true },
                compress: { warnings: false }
              }));
            }

            if (hash) {
              plugins.push((0, _plugins.mapJSONWebpackPlugin)({ assetsPath: packageMap.name, cache: cache }));
            }

            context.plugins = plugins;

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}(); /**************************************************
      * Created by nanyuantingfeng on 27/10/2017 16:25.
      **************************************************/


module.exports = exports['default'];